package org.robotlegs.utilities.modulesignal.mvcs
{
	import flash.display.DisplayObjectContainer;
	import flash.system.ApplicationDomain;
	
	import org.robotlegs.core.IInjector;
	import org.robotlegs.core.ISignalCommandMap;
	import org.robotlegs.utilities.IDisposable;
	import org.robotlegs.utilities.modular.core.IModuleContext;
	import org.robotlegs.utilities.modular.mvcs.ModuleContext;
	import org.robotlegs.utilities.signals.SignalCommandMapDisposable;
	
	
	public class ModuleSignalContext extends ModuleContext implements IModuleContext
	{	
		protected var _signalCommandMap:ISignalCommandMap;
		
		public function ModuleSignalContext(contextView:DisplayObjectContainer=null, autoStartup:Boolean=true, parentInjector:IInjector = null, applicationDomain:ApplicationDomain = null)
		{
			super(contextView, autoStartup, parentInjector, applicationDomain);
		}
		
		public function get signalCommandMap():ISignalCommandMap
		{
			return _signalCommandMap || (_signalCommandMap = new SignalCommandMapDisposable(injector.createChild(injector.applicationDomain)));
		}
		
		public function set signalCommandMap(value:ISignalCommandMap):void
		{
			_signalCommandMap = value;
		}
		
		override protected function mapInjections():void
		{
			super.mapInjections();
			injector.mapValue(ISignalCommandMap, signalCommandMap);
		}
		
		public override function dispose():void
		{
			if(_signalCommandMap is IDisposable)
			{
				IDisposable(_signalCommandMap)._dispose();
			}
			_signalCommandMap = null;
			
			super.dispose();
		}
	}
}